//---------------------------------------------------------------------------
/*
Remote Train Control Program for Windows

 Copyright 2016 by Mark DiVecchio

    This file is part of Remote Train Control.

    Remote Train Control is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Remote Train Control is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Remote Train Control.  If not, see <http://www.gnu.org/licenses/>.

*/
//---------------------------------------------------------------------------
#ifndef Command_QueryH
#define Command_QueryH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "AbNumEdit.hpp"
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TCommand_Query_Form : public TForm
{
__published:	// IDE-managed Components
	TEdit *ButtonName;
	TLabel *Label1;
	TComboBox *ButtonCommand;
	TAbNumSpin *P1;
	TLabel *P1Label;
	TLabel *Label5;
	TImage *Copyright;
	TButton *OKButton;
	TButton *CancelButton;
	TLabel *Question;
	TAbNumSpin *P2;
	TLabel *P2Label;
	TPanel *EngPanel;
	TLabel *EngNoLabel;
	TAbNumSpin *ButtonEngNo;
	TCheckBox *LashUpCheckBox;
	TButton *ClearButton;
	TPanel *P3Panel;
	TLabel *P3Label;
	TEdit *P3;
	TPanel *TIUPanel;
	TLabel *TIUNoLabel;
	TAbNumSpin *ButtonTIUNo;
	TButton *BrowseButton;
	TOpenDialog *PBDialog;
	void __fastcall FormShow(TObject *Sender);
	void __fastcall ButtonEngNoValueChanged(TObject *Sender);
	void __fastcall ButtonCommandChange(TObject *Sender);
	void __fastcall LashUpCheckBoxClick(TObject *Sender);
	void __fastcall ClearButtonClick(TObject *Sender);
	void __fastcall BrowseButtonClick(TObject *Sender);
	void __fastcall OKButtonClick(TObject *Sender);
	void __fastcall CancelButtonClick(TObject *Sender);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall PBDialogShow(TObject *Sender);
private:	// User declarations
public:		// User declarations
	__fastcall TCommand_Query_Form(TComponent* Owner);
    int ButtonNo;
};
//---------------------------------------------------------------------------
extern PACKAGE TCommand_Query_Form *Command_Query_Form;
//---------------------------------------------------------------------------
#endif
