//---------------------------------------------------------------------------
/*
Remote Train Control Program for Windows

(c) Copyright 2015 by Mark DiVecchio

    This file is part of Remote Train Control.

    Remote Train Control is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Remote Train Control is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Remote Train Control.  If not, see <http://www.gnu.org/licenses/>.

*/
//---------------------------------------------------------------------------
#ifndef DCS_Setup_ControlsH
#define DCS_Setup_ControlsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "_GClass.hpp"
#include "AbSwitch.hpp"
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include "AbCBitBt.hpp"
//---------------------------------------------------------------------------
class TDCS_Setup : public TForm
{
__published:	// IDE-managed Components
	TButton *HideButton;
	TLabel *Signal_Controls_Label;
	TPanel *DCSSetupPanel;
	TAbRockerSwitch *Var1Signal;
	TAbRockerSwitch *Var1ModeSwitch;
	TAbRockerSwitch *Fixed1Signal;
	TLabel *Label16;
	TLabel *Label22;
	TLabel *Label1;
	TLabel *Label2;
	TLabel *Label17;
	TLabel *Label23;
	TPanel *Panel1;
	TLabel *Label15;
	TButton *AllSignalOn;
	TButton *AllSignalOff;
	TLabel *Label3;
	TLabel *Label4;
	TLabel *Label20;
	TLabel *Label12;
	TAbRockerSwitch *Fixed2Signal;
	TAbRockerSwitch *Var2Signal;
	TAbRockerSwitch *Var2ModeSwitch;
	TLabel *Label21;
	TLabel *Label13;
	TImage *Copyright;
	void __fastcall Var1ModeSwitchStatusChanged(TObject *Sender);
	void __fastcall Var2ModeSwitchStatusChanged(TObject *Sender);
	void __fastcall AllSignalOnClick(TObject *Sender);
	void __fastcall AllSignalOffClick(TObject *Sender);
	void __fastcall HideButtonClick(TObject *Sender);
	void __fastcall Var1SignalStatusChanged(TObject *Sender);
	void __fastcall Fixed1SignalStatusChanged(TObject *Sender);
	void __fastcall Fixed2SignalStatusChanged(TObject *Sender);
	void __fastcall Var2SignalStatusChanged(TObject *Sender);

private:	// User declarations
    int EngineNo, TIUNo, RemoteNo, ChannelNo;
    String RegFileRootKey;

public:		// User declarations
	__fastcall TDCS_Setup(TComponent* Owner);
  	__fastcall TDCS_Setup(TComponent* Owner, int, int, int);
    __fastcall ~TDCS_Setup(void);
    HWND ParentHandle;
};
//---------------------------------------------------------------------------
extern PACKAGE TDCS_Setup *DCS_Setup;
//---------------------------------------------------------------------------
#endif
