//---------------------------------------------------------------------------
/*
Remote Train Control Program for Windows

 Copyright 2019 by Mark DiVecchio

    This file is part of Remote Train Control.

    Remote Train Control is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Remote Train Control is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Remote Train Control.  If not, see <http://www.gnu.org/licenses/>.

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#include <tchar.h>
#pragma hdrstop

#include "Message_Popup.h"
#include "Train_Control.h"
#include "Setup_Control.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMessagePopup *MessagePopup;
//---------------------------------------------------------------------------
__fastcall TMessagePopup::TMessagePopup(TComponent* Owner)
	: TForm(Owner)
{
assert(false);	// never called since I used the overloaded constructor below
}
//---------------------------------------------------------------------------

__fastcall TMessagePopup::TMessagePopup(TComponent* Owner, HWND Parent, WPARAM wp, LPARAM lp)
	: TForm(Owner)
{
// grab the Parent's Handle
ParentHandle = Parent;
// grab the message params
WParam = wp;
LParam = lp;
Tag = 0;		// simple popup message unless changed, if Tag == 1, it's a stop playback window
				// if Tag == 2, it's a stop PFA window
}
//---------------------------------------------------------------------------

void __fastcall TMessagePopup::ButtonClick(TObject *Sender)
{
Button->Visible = false;
// Tag == 1 means this is a playback window and button is a cancel button
if (Button->Tag == 1) {
	// Send a stop Playback message to Parent
    if (ParentHandle) {
    	(void) PostMessage(ParentHandle, CM_STOPPLAYBACK, WParam, LParam);
        }
	}
// Tag == 2 means this is a PFA window and button is a cancel button
if (Button->Tag == 2) {
	// Send a stop PFA message to Parent
    if (ParentHandle) {
    	(void) PostMessage(ParentHandle, CM_STOPPFA, WParam, LParam);
        }
    }
}
//---------------------------------------------------------------------------


