//---------------------------------------------------------------------------
/*
Remote Train Control Program for Windows

 Copyright 2019 by Mark DiVecchio

    This file is part of Remote Train Control.

    Remote Train Control is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Remote Train Control is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Remote Train Control.  If not, see <http://www.gnu.org/licenses/>.

*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifndef Message_ThreadH
#define Message_ThreadH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------

#include "Message_Popup.h"

class TMessageDisplayThread : public TThread
{
private:
	String Msg_Caption, Msg_MessageLine, Msg_StatusLine;
	int Msg_Delay;
	TMessagePopup * MyMessagePopup;
	HWND ParentHandle;
    TForm * CallingScreen; 	// this pointer must be local to each Thread
	__fastcall TMessageDisplayThread(bool CreateSuspended);

protected:
	void __fastcall Execute();
    void __fastcall Msg_Up();
    void __fastcall Msg_Dn();
    void __fastcall RunOnTerminate(TObject * Sender);

public:
    __fastcall TMessageDisplayThread(bool CreateSuspended, TForm * Callingthis, HWND Parent,
		String Caption, String MessageLine, String StatusLine = "", int dly = 2000);
	__fastcall TMessageDisplayThread::~TMessageDisplayThread();

    bool Finished;
};
//---------------------------------------------------------------------------
#endif
