//---------------------------------------------------------------------------
/*
Remote Train Control Program for Windows

 Copyright 2015 by Mark DiVecchio

    This file is part of Remote Train Control.

    Remote Train Control is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Remote Train Control is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Remote Train Control.  If not, see <http://www.gnu.org/licenses/>.

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>

#include "Train_Control.h"
#include "Debug_Controls.h"

#include "RTC_Help.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRTCHelp *RTCHelp;
//---------------------------------------------------------------------------
__fastcall TRTCHelp::TRTCHelp(TComponent* Owner)
	: TForm(Owner)
{
//
// Fill the Help Text Memo
//
const String HelpFile = String(MainForm->cStartDir) + "\\Help.txt";
// if the file exists, overwrite the internal data
if (FileExists(HelpFile)) {
	HelpInfo->Clear();
    HelpInfo->Lines->LoadFromFile(HelpFile);
    if (DEBUGGING) DB->Debug_Print("Help Text Read from " + HelpFile);
	}
}
//---------------------------------------------------------------------------
void __fastcall TRTCHelp::HideButtonClick(TObject *Sender)
{
Hide();	
}
//---------------------------------------------------------------------------


