//---------------------------------------------------------------------------
/*
Remote Train Control Program for Windows

 Copyright 2015 by Mark DiVecchio

    This file is part of Remote Train Control.

    Remote Train Control is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Remote Train Control is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Remote Train Control.  If not, see <http://www.gnu.org/licenses/>.

*/
// Home Page : http://www.silogic.com/trains/RTC_Running.html
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Super_TIU_Mode.h"
#include "Message_Popup.h"
#include "Train_Control.h"
#include "Setup_Control.h"
#include "PBFileThread.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "_GClass"
#pragma link "AbSwitch"
#pragma resource "*.dfm"
TSuperTIU *SuperTIU;
//---------------------------------------------------------------------------
__fastcall TSuperTIU::TSuperTIU(TComponent* Owner)
	: TForm(Owner)
{
EnableSuperTIU->Checked = Setup->SuperTIUMode;
TIU1->Checked = Setup->TIUSuperMode[0];
TIU2->Checked = Setup->TIUSuperMode[1];
TIU3->Checked = Setup->TIUSuperMode[2];
TIU4->Checked = Setup->TIUSuperMode[3];
TIU5->Checked = Setup->TIUSuperMode[4];

LocalTransparencyOverride = false;
}
//---------------------------------------------------------------------------
void __fastcall TSuperTIU::HideButtonClick(TObject *Sender)
{
Hide();	      // Same as setting Visible to false	
}
//---------------------------------------------------------------------------
void __fastcall TSuperTIU::TIU1Click(TObject *Sender)
{
Setup->TIUSuperMode[0] = TIU1->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TSuperTIU::TIU2Click(TObject *Sender)
{
Setup->TIUSuperMode[1] = TIU2->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TSuperTIU::TIU3Click(TObject *Sender)
{
Setup->TIUSuperMode[2] = TIU3->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TSuperTIU::TIU4Click(TObject *Sender)
{
Setup->TIUSuperMode[3] = TIU4->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TSuperTIU::TIU5Click(TObject *Sender)
{
Setup->TIUSuperMode[4] = TIU5->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TSuperTIU::EnableSuperTIUClick(TObject *Sender)
{
Setup->SuperTIUMode = EnableSuperTIU->Checked;
}
//---------------------------------------------------------------------------
// Workaround for SetLayeredWindowAttributes() to make transparent windows
extern lpfnSetLayeredWindowAttributes m_pSetLayeredWindowAttributes;
//---------------------------------------------------------------------------

void __fastcall TSuperTIU::FormActivate(TObject *Sender)
{
#if __BORLANDC__ >= 0x720      // CB10.1 only
AlphaBlend = false; // Remove Transparency
#else
// Remove WS_EX_LAYERED from this window styles
SetWindowLong(Handle, GWL_EXSTYLE, GetWindowLong(Handle, GWL_EXSTYLE) & ~WS_EX_LAYERED);
// Ask the window and its children to repaint
//Repaint();
#endif
}
//---------------------------------------------------------------------------

void __fastcall TSuperTIU::FormDeactivate(TObject *Sender)
{
if (Setup->TransparentSpin->Value == Setup->TransparentSpin->MaxValue) return;	// Off
if (LocalTransparencyOverride) return;
#if __BORLANDC__ >= 0x720      // CB10.1 only
AlphaBlendValue = (255 * Setup->TransparentSpin->Value) / 100;
AlphaBlend = true;  // Add Transparency
#else
// Set WS_EX_LAYERED on this window
SetWindowLong(Handle, GWL_EXSTYLE, GetWindowLong(Handle, GWL_EXSTYLE) | WS_EX_LAYERED);
//SetLayeredWindowAttributes
m_pSetLayeredWindowAttributes(Handle, NULL, (255 * Setup->TransparentSpin->Value) / 100, LWA_ALPHA);
#endif
}
//---------------------------------------------------------------------------

void __fastcall TSuperTIU::SuperTIU_LabelClick(TObject *Sender)
{
LocalTransparencyOverride = !LocalTransparencyOverride;	// Toggle transparency locally
}
//---------------------------------------------------------------------------

